import numpy as np


class InterfaceModel:
    """Interface for working with AI methods"""
    def predict(self, decoded_data: np.array, params: dict) -> dict:
        """Get predictions on the data flow"""
        pass

    def apply_predictions(self, image: np.array, predictions: dict) -> np.array:
        """Apply predictions to the data stream"""
        pass

    def execute_save(self):
        """Save data"""
        pass
