var presavedData


async function pasteData(model) {
    const modalTable = document.getElementById(`modal_table_${model}`)
    // Check that the data has not been entered
    if (modalTable.children.length === 0) {
        const predictions = presavedData["predictions"][`Identification_${model}`]

        const columns_names = Object.keys(predictions)
        let thead = "<th scope=\"col\">#</th>"
        for (const column_name of columns_names) {
            thead += `<th scope="col">${column_name}</th>`
        }

        let tbody = ""
        for (const i in predictions[columns_names[0]]) {
            tbody += `<tr>`
            for (const [column_id, column_name] of columns_names.entries()) {
                if (column_id === 0) {
                    tbody +=
                        `
                        <th scope="row">
                            <div class="form-check">
                                <input id="checkbox_${model}_${i}" class="form-check-input" type="checkbox" name="checkboxes_models">
                            </div>
                        </th>
                        <td>
                            <input id="input_${model}_${i}" class="form-control" type="text" value="${predictions[column_name][i]}" aria-label="input" style="width: 150px;">
                        </td>
                        `
                } else {
                    tbody += `<td>${predictions[column_name][i]}</td>`
                }
            }
            tbody += `</tr>`
        }

        modalTable.innerHTML =
                `
                <thead>
                    <tr>
                        ${thead}
                    </tr>
                </thead>
                <tbody>
                    ${tbody}
                </tbody>
                `
    }
}


async function save() {
    // Extract frontend data
    const data = getFrontendData()
    // Send POST request to backend
    let response = null
    try {
        const status = await fetch("/save", {
            method: "POST",
            headers: {
                "Content-Type": "application/json"
            },
            body: JSON.stringify(data)
        })
        response = await status.json()
    } catch (err) {
        // Handle the error
        console.error(err)
    }
    // Display status
    alert(JSON.stringify(response["status"]))
}


function getFrontendData() {
    const coms = []
    const params = {anns: {}, changed_data: {}}

    const checkboxesModels = document.getElementsByName("checkboxes_models")
    for (const checkboxModel of checkboxesModels) {
        if (checkboxModel.checked) {
            const [model, i] = checkboxModel.id.split("checkbox_").slice(-1)[0].split("_")
            const method_model = `Identification_${model}`
            const method_model_row = Object.fromEntries(
                Object.entries(presavedData["predictions"][method_model]).map(
                    ([column_name, values]) => {
                        let updateValues = values[Number(i)]
                        if (column_name === "name") {
                            updateValues = document.getElementById(`input_${model}_${i}`).value
                        }
                        return [column_name, [updateValues]]
                    })
            )
            if (!coms.includes(method_model)) {
                coms.push(method_model)
                params["anns"][method_model] = true
                params["changed_data"][method_model] = method_model_row
            } else {
                for (const column_name in params["changed_data"][method_model]) {
                    params["changed_data"][method_model][column_name] = params["changed_data"][method_model][column_name].concat(method_model_row[column_name])
                }
            }
        }
    }

    return {commands: coms, params: params}
}


async function loadPage() {
    const modals = document.querySelectorAll(".modal")
    const coms = [...modals].map(model => `Identification_${model.id.split("modal_").slice(-1)[0]}`)
    try {
        const response = await fetch("/get_presaved_data", {
            method: "POST",
            headers: {
                "Content-Type": "application/json"
            },
            body: JSON.stringify({commands: coms})
        })
        presavedData = await response.json()
    } catch (err) {
        // Handle the error
        console.error("An exception occurred (record/predict)", err.message)
    }

    if (presavedData) {
        // Paste image
        document.querySelector("img").src = presavedData["byte_data"]
    }
}


loadPage()
