var presavedData


async function save() {
    // Extract frontend data
    const data = getFrontendData()
    // Send POST request to backend
    let response = null
    try {
        const status = await fetch("/save", {
            method: "POST",
            headers: {
                "Content-Type": "application/json"
            },
            body: JSON.stringify(data)
        })
        response = await status.json()
    } catch (err) {
        // Handle the error
        console.error(err)
    }
    // Display status
    alert(JSON.stringify(response["status"]))
}


function getFrontendData() {
    const coms = []
    const params = {anns: {}}

    const checkboxes = document.getElementsByName('checkbox_methods')
    for (const checkbox of checkboxes) {
        if (checkbox.checked) {
            const method = checkbox.id
            const innerCheckboxes = document.getElementsByName(method)
            for (const innerCheckbox of innerCheckboxes) {
                if (innerCheckbox.checked) {
                    coms.push(innerCheckbox.id)
                }
            }
        }
    }

    const annsCheckboxes = document.getElementsByName('custom_data')
    for (const annsCheckbox of annsCheckboxes) {
        const method_model =  annsCheckbox.id.split("custom_data_").slice(-1)[0]
        params["anns"][method_model] = annsCheckbox.checked
    }

    return {commands: coms, params: params}
}


async function loadPage() {
    try {
        const response = await fetch("/get_presaved_data", {
            method: "POST",
            headers: {
                "Content-Type": "application/json"
            }
        })
        presavedData = await response.json()
    } catch (err) {
        // Handle the error
        console.error("An exception occurred (record/predict)", err.message)
    }

    // Paste image
    document.querySelector("img").src = presavedData["byte_data"]
    // Paste predictions
    for (const methodModel in presavedData["predictions"]) {
        const contentDes = document.getElementById(`content_des_${methodModel}`)
        contentDes.textContent = JSON.stringify(presavedData["predictions"][methodModel])
    }
}


loadPage()
